# GearSolid: Gestión de Acceso a Recursos Solidarios

## Descripción
La aplicación permitirá la gestion de compromisos y usuarios de la Fundacion Coordinadora Solidaria.
Entre sus capacidades estará agendar todos los compromisos de los usuarios del recurso, tanto las citas de acogida en la que los candidatos presentan su documentación y obtienen (o no) su validacion como usuarios, las recogidas de alimentos en caso de ser designados como usuarios de pleno derecho del recurso y las asistencias obligatorias a los compromisos de formación.
La aplicación tambien ha de permitir la creación, modificación, consulta o borrado en cualquier momento de los compromisos y sus datos, la generación de informes y listados de citas previstas de personal para cada trabajador social y el registro de las asistencias a los recursos, asi como la creacion de informes que serán necesarios par la consecución de subvenciones.
Además, es preciso contar con un sistema de validacion de expedientes que registre los datos y ver si se cumplen con los criterios de prioridades para ser asignados al recurso.
Será una aplicación Web de escritorio que permita el acceso a varios trabajadores simultaneamente, no limitandose únicamente a red local.

## Diagrama de clases de diseño

![Diagrama de Diseño MVP](https://git.institutomilitar.com/GuerreroDIM46/gestionsolid/-/wikis/Imagenes/DiagramaDeClasesV4.drawio.jpg)

## Cumplimiento de requisitos

1. **Herencia**: Hay herencias entre `Compromiso` y sus subtipos.
2. **Relación One-To-Many**: Relación entre `Usuario` y sus `Compromisos` asociados.
3. **Método personalizado**: Se generará un listado semana con los nombres de los usuarios, la hora, la fecha, el dia, y el tipo y numero de racciones que tienen que recoger como parte de su compromiso de recogida de alimentos, impreso.
4. **Listado**:  Se representará el listado de compromisos  de cada `Usuario`. (Figura 1). 
5. **CRUD**: Se realizara un CRUD completo de `Compromiso`, representado en la figura 2 y 3, segun su herencia. 
6. **URLs** del proyecto:  
   1. Repositorio proyecto: https://git.institutomilitar.com/GuerreroDIM46/gestionsolid

7. **Despliegue en Internet:**  
    * API: https://gearsolid-a2f9e86feda7.herokuapp.com/api/
    * Web: https://gearsolid.netlify.app  
  
## Interfaz de usuario

### Figura 1: Listado de trabajadores y expedientes asociados:  
![Figura 1](https://git.institutomilitar.com/GuerreroDIM46/gestionsolid/-/wikis/Imagenes/ListadoV4.drawio.jpg)

### Figura 2: Compromiso Recogida Alimentos:  
![Figura 2](https://git.institutomilitar.com/GuerreroDIM46/gestionsolid/-/wikis/Imagenes/CRUDCompromisoAlimentosV2.drawio.jpg)

### Figura 3: Compromiso Formación:  
![Figura 3](https://git.institutomilitar.com/GuerreroDIM46/gestionsolid/-/wikis/Imagenes/CRUDCompromisoFormacionV2.drawio.jpg)

[Volver Arriba](#índice)
