import {
  getFranjas
} from '@/stores/api-gearsolid.js'

import { defineStore } from 'pinia'

export const useAlmacenFranjasStore = defineStore('franjas', {
  state: () => ({
    cargado: false,
    franjas: new Map(),
    grupos: null,
    dias : {
      L: 'Lunes',
      M: 'Martes',
      X: 'Miércoles',
      J: 'Jueves',
      V: 'Viernes',
      S: 'Sábado',
      D: 'Domingo'
    }
  }),
  getters: {
    //Funciones que acceden y calculan valores derivados del estado del almacén
   
  },
  actions: {
    async descargarFranjas() {
      const respuestaAPI = await getFranjas()
      if (respuestaAPI.status === 200) {
        if (respuestaAPI.data._embedded.franjas != null) {
          let franjasDescargadas = respuestaAPI.data._embedded.franjas
          franjasDescargadas.forEach(franjaDescargada => {
            //let idFranja = franjaDescargada._links.self.href.substring(franjaDescargada._links.self.href.lastIndexOf("/") + 1)
            let idFranja = franjaDescargada._links.self.href
            this.franjas.set(idFranja, {
              dias: franjaDescargada.dias,
              hora: franjaDescargada.hora,
              plazasTotales: franjaDescargada.plazasTotales,
              plazasDisponibles: franjaDescargada.plazasDisponibles,
              franjaDisponible: franjaDescargada.franjaDisponible
            }) 
          })
        }
        this.cargado = true
      }
    },

     // retorna un array con los posibles grupos que se encuentran en las franjas (A: L M V, B: M X J...)
     async getGrupos(){
      if (!this.cargado){
        await this.descargarFranjas()
      }
      let grupos = []
      for (let [id, franja] of this.franjas){
        if (!grupos.includes(franja.dias)){
          grupos.push(franja.dias)
        }
      }
      console.log(`franjas.js: grupos: ${grupos}`)
      this.grupos=grupos
      return grupos
    }
  }
})