import {defineStore} from "pinia"
import {
        getUsuarios,
        postUsuario,
        patchUsuario
}  from '@/stores/api-gearsolid.js'
export const useUsuariosStore = defineStore('usuarios', {
    state:() => ({
                    //propiedades exportables
                    usuariosAlta : new Map(),
                    usuariosBaja : new Map()
                }),
    getters:{
                    //Funciones que acceden y calculan valores derivados del estado del almacén
            },
    actions:{
        // Funciones que realizan operaciones asíncronas o con lógicas más complejas
        async mapearUsuarios(){
                let usuarios = await getUsuarios()
                
                if ( usuarios.data._embedded.usuariosAlta != null){
                        usuarios.data._embedded.usuariosAlta.forEach(usuario => {
                                this.usuariosAlta.set(usuario._links.self.href, {
                                        "nombre": usuario.nombre,
                                        "estado": "alta",
                                        "trabajador": usuario.trabajador,
                                        "telefono": usuario.telefono,
                                        "numeroMenores": usuario.numeroMenores,
                                        "ingresosUnidadFamiliar": usuario.ingresosUnidadFamiliar,
                                        "compromisos": usuario._links.compromisos.href
                                })
                        });
                }                 
                this.usuariosMapeados=true                
        },

        async enviarPostUsuario(usuario) {
                const respuestaAPI = await postUsuario(usuario)

                if (respuestaAPI.status == 201) {
                //El id lo marca la API (actualizo el id en el usuario a partir de la respuesta de la API)
                let idUsuario = respuestaAPI.data._links.self.href
                usuario.id = idUsuario
                this.usuariosAlta.set(idUsuario,{
                        "nombre": usuario.nombre,
                        "estado": "alta",
                        "trabajador": usuario.trabajador,
                        "telefono": usuario.telefono,
                        "numeroMenores": usuario.numeroMenores,
                        "ingresosUnidadFamiliar": usuario.ingresosUnidadFamiliar,
                        })

                }
        },

        async actualizarUsuario(usuario) {
                let retorno = false
                let idUsuario = usuario.id.split('/').pop()
                let usuarioModificado = {
                        nombre: usuario.nombre,
                        trabajador: usuario.trabajador,
                        telefono: usuario.telefono,
                        numeroMenores: usuario.numeroMenores,
                        ingresosUnidadFamiliar: usuario.ingresosUnidadFamiliar
                }
                const respuestaAPI = await patchUsuario(idUsuario, usuarioModificado)
                if (respuestaAPI.status == 200) {
                     this.usuariosAlta.set(usuario.id,
                        usuarioModificado
                     )
                     retorno = true
                }
                return retorno
        },

///////////////////////             
        //     async enviarDeleteUsuario(usuario) {
    
        //         const respuestaAPI = await deleteCompromiso(compromiso.id)
    
        //         if (respuestaAPI.status == 200) {
    
        //             if (compromiso.tipo == "formacion") {
        //                 this.formaciones = this.formaciones.filter((formacion => {
        //                     return formacion.id != compromiso.id
        //                 }), 0)
    
        //             } else if (compromiso.tipo == "recogidaAlimento") {
        //                 this.recogidasAlimento = this.recogidasAlimento.filter((recogidaAlimento => {
        //                     return recogidaAlimento.id != compromiso.id
        //                 }), 0)
    
        //             }
        //         }
        //     }

        }
})