package es.mde.gearsolid.repositorios;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;
import es.mde.gearsolid.entidades.RecogidaAlimento;


/**
 * Representa los métodos para acceso a la Entidad RecogidaAlimento en la Base de Datos Implementa
 * la interfaz {@link RecogidaAlimentoCustom} que contiene la firma de los métodos personalizados
 * 
 * @author Rodrigo De Dios García
 * @version 0.1
 */
@RepositoryRestResource(path = "recogidasAlimento", itemResourceRel = "recogidaAlimento",
    collectionResourceRel = "recogidasAlimento")
public interface RecogidaAlimentoDAO
    extends JpaRepository<RecogidaAlimento, Integer>, RecogidaAlimentoCustom {

}
