package es.mde.gearsolid.repositorios;

import java.util.List;
import java.util.stream.Collectors;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import es.mde.gearsolid.entidades.RecogidaAlimento;
import jakarta.persistence.EntityManager;
import jakarta.persistence.PersistenceContext;

/**
 * Implementación de la interfaz que contiene los métodos personalizados para la entidad
 * RecogidaAlimento
 * 
 * @author Rodrigo De Dios García
 * @version 0.1
 */
@Transactional(readOnly = true)
public class RecogidaAlimentoDAOImpl implements RecogidaAlimentoCustom {

  @Autowired
  RecogidaAlimentoDAO recogidaAlimentoDAO;

  @PersistenceContext
  EntityManager entityManager;

  public RecogidaAlimentoDAOImpl() {
    // TODO Auto-generated constructor stub
  }

  @Override
  public List<RecogidaAlimento> getRecogidaAlimentoPorGrupo(String grupo, Long inicioSemana) {
    return recogidaAlimentoDAO.findAll().stream().filter(recogida -> {
      return (recogida.getFranja().getDias().equals(grupo)
          && (recogida.getFechaInicio().getTime() <= inicioSemana));
    }).collect(Collectors.toList());


  }

}
